
 exports.findChild = function(value, tree, key="id", childArray="children") {
    var nodes = []
    if (value === tree[key]) {
      return tree
    } else if (!tree[childArray]) {
      return undefined
    } else {
      tree[childArray].forEach(child => {
        nodes.push(findChild(value, child, key, childArray ))
      })
    }
    return nodes.filter(child => child !== undefined)[0]
  }



exports.editChild = function(value, newObj, initialObj, key="id", childrenArray="children") {
    if (value === initialObj[key]) return newObj
    if (!initialObj[childrenArray]) return initialObj

    return Object.assign(initialObj, {[childrenArray]: initialObj[childrenArray].map(child => {
      return editChild(value, newObj, child, key, childrenArray, child)})})
    // return Object.assign({[childrenArray]: initialObj[childrenArray].map(child => {
    //   return editChild(value, newObj, child, key, childrenArray, child)
    // })}, initialObj)
    // return {...initialObj,
    //   [childrenArray]: initialObj[childrenArray].map(child => {
    //     return editChild(value, newObj, child, key, childrenArray, child)
    //   })

  }

// exports.findChild = function (value, tree, key="id", childArray="children") {
//
//     var nodes = []
//     if (value === tree[key]) {
//       return tree
//     } else if (!tree[childArray]) {
//       return
//     } else {
//       tree[childArray].forEach(child => {
//         nodes.push(findChild(value, child, key, childArray ))
//       })
//     }
//     return nodes.filter(child => child !== undefined)[0]
//   }

  // exports.editChild = function (value, newObj, initialObj, key="id", childrenArray="children") {
  //   if (value === initialObj[key]) return newObj
  //   if (!initialObj[childrenArray]) return initialObj
  //   return {...initialObj,
  //     [childrenArray]: initialObj[childrenArray].map(child => {
  //       return editChild(value, newObj, child, key, childrenArray, child)
  //     })
  //   }
  // }

exports.deleteChild = function(value, initialObj,  key="id", childrenArray="children") {
    if (!initialObj[childrenArray]) {
      var newObj = {}
      for (key in initialObj) {
        if (key !== childrenArray) {
          newObj[key] = initialObj[key]
        }
      }
      return newObj
    } else {
      const children = initialObj[childrenArray].map( child => child[key])
      const index = children.indexOf(value)
      const newObj = {}
      if (index !== -1) {

        if (children.length > 0) {
          var obj = {}
          for (key in initialObj) {
            if (key !== childrenArray) {
              obj[key] = initialObj[key]
            } else {
              obj[key] = initialObj[childrenArray].slice(0, index).concat(initialObj[childrenArray].slice(index + 1))
            }
          }
          return obj
        } else {
          return Object.assign({children: null}, initialObj)
          // return {...initialObj, children: null }
          // return obj
        }
        return Object.assign({[childrenArray]: initialObj[childrenArray].slice(0, index).concat(initialObj[childrenArray].slice(index + 1)), initialObj })
        // return {...initialObj, [childrenArray]: initialObj[childrenArray].slice(0, index).concat(initialObj[childrenArray].slice(index + 1))}
      } else {
        return Object.assign({[childrenArray]: initialObj[childrenArray].map(child => deleteChild(value, child, key, childrenArray))}, initialObj )

        // return {...initialObj,
        //   [childrenArray]: initialObj[childrenArray].map(child => deleteChild(value, child, key, childrenArray))

      }
    }
  }
// console.log("hello")
// const newestTree = {name: "app", children: [{"name": "mom"}, {"name": "hello"}]}
  // console.log(findChild("mom", newestTree, "name", "children"))
